<?php
/**************************************************
  CPG Photo Shop Plugin for Coppermine Photo Gallery
  *************************************************
  Copyright (c) 2006 Thomas Lange <stramm@gmx.net>
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  *************************************************
  Coppermine version: 1.4.16
  Photo Shop version: 1.3.6
  $Revision: 1.0 $
  $Author: stramm $
***************************************************/

//calculate item prices, for the CD (and if there are less/ to many images on it), all photos
function item_price($cd_counter) { // all totals!! return[0] = photo price, return[1] = cd price, return[2] = to many items in cd error (if set)

	global $SHOP_CONFIG, $lang_photoshop, $CONFIG;
	$return = array();
	foreach($_SESSION['photoshop']['cart'] as $key => $temp){//foreach count photo items

		$item_id = (isset($_SESSION['photoshop']['cart'][$key]['id'])) ? $_SESSION['photoshop']['cart'][$key]['id'] : '';
		$amount = (isset($_SESSION['photoshop']['cart'][$key]['amount'])) ? $_SESSION['photoshop']['cart'][$key]['amount'] : '';
		$aid = (isset($_SESSION['photoshop']['cart'][$key]['aid'])) ? $_SESSION['photoshop']['cart'][$key]['aid'] : '';

		//price override
		$price = $SHOP_CONFIG[$item_id]['price'];

		$results = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_SHOP_PRICES']} WHERE aid={$_SESSION['photoshop']['cart'][$key]['aid']}");

	    while ($temp_data = mysql_fetch_array($results)) {
			if($temp_data['gid']==$SHOP_CONFIG[$item_id]['id'])
				$price=$temp_data['price'];
		}
		mysql_free_result($results);

		$return[0] += $amount*$price;
	}

	if ($cd_counter > 0) { //if we have an item added to cd
		$pricelist = array();
		foreach($SHOP_CONFIG as $key => $value){//foreach
			if ($value['type']=="cd") $pricelist[$key]=$value['max_items'];
		}
		arsort($pricelist);
		foreach ($pricelist as $key => $val) {
			if ($val >= $cd_counter){
				$pointer=$key;
				$check=true;
			}

		}
		$return[3] = true;
		$return[2] = '';
		$return[1] = $SHOP_CONFIG[$pointer]['price'];
		if(!$check==true) {
			$return[3] = false;
			$return[2] = "<font color=\"red\">".$lang_photoshop['to_many_pics']."</font>&nbsp;<br />";
			$return[1] = '';
		}
	} else {
		$return[1] = '';//end if we have an item added to cd
		$return[3] = true;
	}
	return $return;
}

//count the different items in the cart, doesn't count the same item twice
function photoshop_count_items() { // return['cd'] = number of cd items, return['photo'] = number of print photo items
	global $SHOP_CONFIG;
	$cd_counter = array();
	foreach($_SESSION['photoshop']['cart'] as $key => $temp){//foreach
		$amount = (isset($_SESSION['photoshop']['cart'][$key]['amount'])) ? $_SESSION['photoshop']['cart'][$key]['amount'] : '';
		$item_id = (isset($_SESSION['photoshop']['cart'][$key]['id'])) ? $_SESSION['photoshop']['cart'][$key]['id'] : '';
		if($item_id == 'CD') {
			$cd_counter['cd']++;
		} else {
			$cd_counter['photo'] = $cd_counter['photo'] + $amount;
		}

	}//end foreach
	return $cd_counter;
}

//refresh page
function photoshop_refresh($redirect, $txt='') {
			global $lang_info;

            pageheader($lang_info, "<META http-equiv=\"refresh\" content=\"0;url={$redirect}\">");
            if($txt !='') {
				msg_box ($txt, $txt);
			}
            pagefooter();
            ob_end_flush();
			exit;
}

//display a pricelist
function photoshop_pricelist(){
	global $lang_photoshop, $SHOP_CONFIG, $CONFIG;
	starttable('100%', $lang_photoshop['pricelist'], 2);
	$cd_pricelist = '';
	$photo_pricelist = '';
	$shipping_pricelist = '';
	$shipping_pricelist2 = '';
	$photo_desc = '';
	$cd_desc = '';
	$ship_desc = '';
	foreach($SHOP_CONFIG as $key => $value) {
		if ((is_numeric($key))) {
			if($SHOP_CONFIG[$key]['type']=="photo"){
				$photo_pricelist .= $SHOP_CONFIG[$key]['name']." - ".$lang_photoshop['USD']." ".$SHOP_CONFIG[$key]['price'] ."<br />";
				if ($SHOP_CONFIG[$key]['ship'] > 0) {
				   $shipping_pricelist2 .= $lang_photoshop['shipping'].' '.$SHOP_CONFIG[$key]['name']." - ".$lang_photoshop['USD']." ".$SHOP_CONFIG[$key]['ship'] ."<br />";
				}
				$photo_desc = $lang_photoshop['photos'];
			} elseif($SHOP_CONFIG[$key]['type']=="cd"){
				$cd_pricelist .= $SHOP_CONFIG[$key]['name']." - ".$lang_photoshop['USD']." ".$SHOP_CONFIG[$key]['price'] ."<br />";
				if ($SHOP_CONFIG[$key]['ship'] > 0) {
				   $shipping_pricelist2 .= $lang_photoshop['shipping'].' '.$SHOP_CONFIG[$key]['name']." - ".$lang_photoshop['USD']." ".$SHOP_CONFIG[$key]['ship'] ."<br />";
				}
				$cd_desc = $lang_photoshop['cds'];
			} elseif($SHOP_CONFIG[$key]['type']=="ship") {
				$shipping_pricelist .= $SHOP_CONFIG[$key]['name']." - ".$lang_photoshop['USD']." ".$SHOP_CONFIG[$key]['price'] ."<br />";
			}
		}
	}

	echo <<<EOT
					<tr style="font-weight:bold;">
						<td><p>{$photo_desc}</p></td>
						<td><p>{$cd_desc}</p></td>
					</tr>
					<tr style="font-size:10px;">
						<td align="left" width="50%" valign="top">
						{$photo_pricelist}
						</td>
						<td align="left" width="50%" valign="top">
						{$cd_pricelist}
						</td>
					</tr>
					<tr>
						<td align="left" colspan="2" valign="top">
						<br><p style="font-weight:bold;">{$lang_photoshop['shipping']}</p>
						<span style="font-size:10px;">{$shipping_pricelist}{$shipping_pricelist2}</span>
						</td>
					</tr>


EOT;

endtable();
}

//calculate and format total, discount, shipping
function photoshop_format_price($temp_price, $cd_counter, $error='', $template){
	global $lang_photoshop, $SHOP_CONFIG;

	$out =array();
	$discount_calc = calculate_discount($temp_price, $cd_counter);
	$shipping_calc = calculate_shipping();
	$discount = number_format(($discount_calc),2);
	$shipping = number_format(($shipping_calc),2);
	$tot_price = number_format(($temp_price[1]+$temp_price[0]+$shipping_calc-$discount_calc),2);
	$cd_price = number_format($temp_price[1],2);
	$photo_price = number_format($temp_price[0],2);

	if ($cd_price > 0) {
		$cd_price2 = "{$lang_photoshop['on_cd']}: {$cd_counter['cd']} {$lang_photoshop['pics']} :: $cd_price{$lang_photoshop['USD']}&nbsp;<br />";
	} else $cd_price2 = '';
	if ($photo_price > 0) {
		$photo_price2 = "{$lang_photoshop['for_print']}: {$cd_counter['photo']} {$lang_photoshop['pics']} :: $photo_price{$lang_photoshop['USD']}&nbsp;<br />";
	} else $photo_price2 = '';

	if ($tot_price > 0) {
		if ($shipping > 0) {
			$total_price = "{$lang_photoshop['shipping']} :: ".$shipping."{$lang_photoshop['USD']}&nbsp;<br>";
		} else $total_price = "";
		if ($discount > 0) {
			$total_price .= "{$lang_photoshop['discount']} :: % {$discount}{$lang_photoshop['USD']}&nbsp;";
		}
		$total_price .= "<hr size=\"1\" width=\"200\" align=\"right\" />&nbsp;";
		$total_price .= "{$lang_photoshop['total']}: {$tot_price}{$lang_photoshop['USD']}&nbsp;";
	} else $tot_price = '';

	$out['html'] = <<<EOT
		<tr>
			<td colspan="6" align="center">
			<hr size="1" />
			</td>
		</tr>
		<tr>
			<td colspan="6" align="right">
				{$photo_price2}
				{$cd_price2}{$error}
				{$total_price}

			</td>
		</tr>
EOT;
	$out['text'] = sprintf("%+63s\n\n", '');
	if ($photo_price > 0) { $out['text'] .= sprintf("%+63s\n", $lang_photoshop['for_print'].': '. $cd_counter['photo'].' '.$lang_photoshop['pics'].' :: '.$photo_price.$lang_photoshop['USD']); }
	if ($cd_price > 0) { $out['text'] .= sprintf("%+63s\n", $lang_photoshop['on_cd'].': '. $cd_counter['cd'].' '.$lang_photoshop['pics'].' :: '.$cd_price.$lang_photoshop['USD']); }
	if ($shipping > 0) {	$out['text'] .= sprintf("%+63s\n", $lang_photoshop['shipping'].' :: '.$shipping.$lang_photoshop['USD']); }
	if ($discount > 0) { $out['text'] .= sprintf("%+63s\n", $lang_photoshop['discount'].' :: %'.$discount.$lang_photoshop['USD']); }
	$out['text'] .= sprintf("%+63s\n", '--------------------------');
	$out['text'] .= sprintf("%+63s\n", $lang_photoshop['total'].': '.$tot_price.$lang_photoshop['USD']);

	return $out[$template];
}

//check the multi dimensional item array for CDs, used in checkout item overview
function photoshop_in_array_multi($needle, $haystack)
{
   if(!is_array($haystack)) return $needle == $haystack;
   foreach($haystack as $value) if(photoshop_in_array_multi($needle, $value)) return true;
   return false;
}

//calculate discounts, user defined
function calculate_discount($temp_price, $cd_counter){

	$discount = '';
	//variables that can be used
	//$cd_counter['photo']  number of pics for print
	//$cd_counter['cd']		number of pics on CD
	//$temp_price[1]		price for the CD
	//$temp_price[0]		price for the pics

	//just to demonstrate how to calculate a discount
	//10% on print images if user orders more than 10 pics
	/*
	if($cd_counter['photo'] >= 10) {
		$discount = 0.1 * $temp_price[0];
	}
	*/

	/*
	//or another example... 10% if the order volume is > 100USD
	if($temp_price[0] >= 100) {
		$discount = 0.1 * $temp_price[0];
	}
	*/
	return $discount;
}

//calculate shipping, user defined
function calculate_shipping(){
global $CONFIG, $SHOP_CONFIG;
   	//global shipping is taken (type=ship), if the per item shipping is set and higher, than it overrides global
	$shipping = $SHOP_CONFIG['ship'];
	foreach($_SESSION['photoshop']['cart'] as $key => $temp){//foreach count photo items

		$item_id = (isset($_SESSION['photoshop']['cart'][$key]['id'])) ? $_SESSION['photoshop']['cart'][$key]['id'] : '';
			if($SHOP_CONFIG[$item_id]['ship'] >= $shipping) {
			  $shipping = $SHOP_CONFIG[$item_id]['ship'];
			}
		}


	return $shipping;
}

?>