<?php
/**************************************************
  CPG Photo Shop Plugin for Coppermine Photo Gallery
  *************************************************
  Copyright (c) 2006 Thomas Lange <stramm@gmx.net>
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  *************************************************
  Coppermine version: 1.4.16
  Photo Shop version: 1.3.6
  $Revision: 1.0 $
  $Author: stramm $
***************************************************/
define('PHOTOSHOP_ORDER_PHP', true);

require('include/init.inc.php');
require('include/mailer.inc.php');
require('include/gateway.inc.php');

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
if (!USER_ID && $CONFIG['allow_unlogged_access'] == 0) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

$lang = isset($USER['lang']) ? $USER['lang'] : $CONFIG['lang'];
if (!file_exists("plugins/photo_shop/lang/{$lang}.php"))
  $lang = 'english';
require "plugins/photo_shop/lang/{$lang}.php";

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
//cart empty??
$cd_counter = photoshop_count_items();
if (($cd_counter['cd']+$cd_counter['photo']) == 0 ) {
			pageheader($lang_photoshop['checkout']);
			starttable('100%', $lang_photoshop['checkout'], 1);
			msg_box('', $lang_photoshop['cart_empty'], $lang_continue, 'index.php');
			pagefooter();
			ob_end_flush();
			exit;
}
//if user isn't logged in redirect to shop register/ login page
if(!USER_ID) {
    photoshop_refresh($_SERVER['PHP_SELF'].'?file=photo_shop/photo_shop_register');
	exit;
}
//start html output
pageheader($lang_photoshop['checkout']);
starttable('100%', $lang_photoshop['checkout'], 1);
endtable();
//start all the if else
$cd_price = item_price($cd_counter['cd']);
if ($cd_price[3] == false) { // more CD items than max defined -> warn and show link to cart
	echo '<tr><td><br>'.$cd_price[2].'<br>'.$lang_photoshop['goto_cart_cd'].'</td></tr>';
} elseif (($_POST['order'] == "confirmed") && (($cd_counter['cd']+$cd_counter['photo']) > 0 )) {
	//add to mysql, show confirmation and send email (user+admin)
	photoshop_prep_data($shop_array_cd, $shop_array_photos);
	//order_id++
	$results = cpg_db_query("SELECT oid FROM {$CONFIG['TABLE_SHOP']} ORDER BY oid DESC LIMIT 1");
	$row = mysql_fetch_array($results);
	$order_id = ++$row['oid'];
	mysql_free_result($results);

	//merge photo und cd array
	$shop_array = array_merge($shop_array_photos, $shop_array_cd);

	//calculate the discount
	$discount_calc = calculate_discount($cd_price, $cd_counter);
	$shipping_price_calc = calculate_shipping();
	$discount = number_format($discount_calc,2);
	$shipping_price = number_format($shipping_price_calc,2);
	if (photoshop_add_data($shop_array, $order_id)) { // adding data succeeded
		//now email the user
		//first we prepare the invoice attachment
		$invoice = '<pre>'; //added to make the output more convenient when viewing the email not as text email but html
		$invoice .= $lang_photoshop_email_attach_header; //in the lang file we could define a header for the invoice
		$invoice .= photoshop_create_table($shop_array_photos, 'photo', 'text');
		$invoice .= photoshop_create_table($shop_array_cd, 'cd', 'text');
		$invoice .= photoshop_format_price($cd_price, $cd_counter, '', 'text');
		$invoice .= '</pre>';


		if(photoshop_email_the_user($lang_photoshop_email_order.$invoice, $lang_photoshop['email_subject_order'])){
			//when user got his email, then send to admin
			photoshop_email_the_user($lang_photoshop_email_admin.$invoice, $lang_photoshop['email_subject_order_admin'], true);

			//here we do the integration... we just add the buttons, text etc to the msg_box

			$item_price = number_format(($cd_price[0]+$cd_price[1]-$discount_calc),2); // - discount (used for paypal, google checkout)
			$order_price = number_format(($cd_price[0]+$cd_price[1]+$shipping_price_calc-$discount_calc),2);
			$msg_box_txt = $lang_photoshop['email_sent'];
			$msg_box_txt .= '<br><br>'.$lang_photoshop['order_id'].' '.$order_id.', '.$lang_photoshop['total'].' '.$order_price.' '.$lang_photoshop['USD'];


			//pay by wire
			if ($CONFIG['photo_shop_wire_enable']) {
				$msg_box_txt .= <<<EOT
					<br><br>{$lang_photoshop['wire']}<br>

					<table>
						<tr>
							<td>{$lang_photoshop['bank']}</td>
							<td>{$CONFIG['photo_shop_wire_bank']}</td>
						</tr>
						<tr>
							<td></td>
							<td>{$CONFIG['photo_shop_wire_bank_address']}</td>
						</tr>
						<tr>
							<td>{$lang_photoshop['routing']}</td>
							<td>{$CONFIG['photo_shop_wire_routing']}</td>
						</tr>
						<tr>
							<td>{$lang_photoshop['account']}</td>
							<td>{$CONFIG['photo_shop_wire_account']}</td>
						</tr>
						<tr>
							<td>{$lang_photoshop['swift']}</td>
							<td>{$CONFIG['photo_shop_wire_swift']}</td>
						</tr>
					</table>
EOT;

			}

			//pay with paypal
			if ($CONFIG['photo_shop_paypal_enable']) {
					$handling = $shipping_price-$discount;
					$paypal_items = "";
					$counter = 0;
					foreach ($shop_array as $key => $item_id) {
						$pid = $item_id['pid'];
						$amount = $item_id['amount'];
						$counter++;
						if ($item_id['id']=="CD") {
							$size = "CD";
							$price = $cd_price[1];
						} else {
							$size = $SHOP_CONFIG[$item_id['id']]['name'];
							$price = $SHOP_CONFIG[$item_id['id']]['price'];

							//price override
							$results = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_SHOP_PRICES']} WHERE aid={$item_id['aid']}");

						    while ($temp_data = mysql_fetch_array($results)) {
								if($temp_data['gid']==$SHOP_CONFIG[$item_id['id']]['id'])
									$price=$temp_data['price'];
							}
							mysql_free_result($results);

							//to grab the image title from the db
							$query = cpg_db_query("SELECT title FROM {$CONFIG['TABLE_PICTURES']} WHERE pid={$item_id['pid']}");
    						$row = mysql_fetch_row($query);
							($row[0]) ? $title= $row[0] : $title="No title";
							mysql_free_result($row);



						$picture_total = ($picture_total+$price*$amount);
						}


					$paypal_items .= 	"<input type=\"hidden\" name=\"item_name_{$counter}\" value=\"Title: {$title} - ID: {$pid}\">";
					$paypal_items .= 	"<input type=\"hidden\" name=\"amount_{$counter}\" value=\"{$price}\">";
					$paypal_items .= 	"<input type=\"hidden\" name=\"quantity_{$counter}\" value=\"{$amount}\">";
					}

				if ($CONFIG['photo_shop_paypal_use_ipn'] == '1') {
					$paypal_notify_url = '<input type="hidden" name="notify_url" value="'.$CONFIG['ecards_more_pic_target'].$CONFIG['photo_shop_paypal_ipn_notify_url'].'">';
					$paypal_notify_url .= '<input type="hidden" name="rm" value="2">';
				} else $paypal_notify_url = '';
				if ($CONFIG['photo_shop_tax'] != '') {
					$paypal_tax = '<input type="hidden" name="tax_cart" value="'.$CONFIG['photo_shop_tax']*$picture_total.'">';
				} else $paypal_tax = '';
				if ($CONFIG['photo_shop_paypal_return_url'] != '') {
					$paypal_return_url = '<input type="hidden" name="return" value="'.urlencode($CONFIG['ecards_more_pic_target'].$CONFIG['photo_shop_paypal_return_url']).'">';
				} else $paypal_return_url = '';
				if ($CONFIG['photo_shop_paypal_cancel_return_url'] != '') {
					$paypal_cancel_return_url = '<input type="hidden" name="cancel_return" value="'.urlencode($CONFIG['ecards_more_pic_target'].$CONFIG['photo_shop_paypal_cancel_return_url']).'">';
				} else $paypal_cancel_return_url = '';

				$msg_box_txt .= <<<EOT
					<br><br>{$lang_photoshop['paypal']}<br>

					<form action="{$CONFIG['photo_shop_paypal_form_url']}" method="post">
					<input type="hidden" name="cmd" value="_cart">
					<input type="hidden" name="upload" value="1">
					<input type="hidden" name="invoice" value="{$order_id}">
					<input type="hidden" name="business" value="{$CONFIG['photo_shop_paypal_email']}">
					<input type="hidden" name="currency_code" value="{$CONFIG['photo_shop_paypal_currency']}">
					{$paypal_items}
					{$paypal_tax}
					{$paypal_return_url}
					{$paypal_cancel_return_url}
					{$paypal_notify_url}
					<input type="hidden" name="handling_cart" value="{$handling}">
					<input type="image" src="{$CONFIG['photo_shop_paypal_image']}" name="submit" alt="Pay with PayPal!">
					</form>

EOT;
			}
			if ($CONFIG['photo_shop_google_enable']) {
				$msg_box_txt .= <<<EOT
					<br><br>{$lang_photoshop['google']}<br>

					<form method="POST" action="https://checkout.google.com/cws/v2/Merchant/{$CONFIG['photo_shop_google_id']}/checkoutForm" accept-charset="utf-8">
	    			<input type="image" name="Google Checkout" alt="Fast checkout through Google" src="http://checkout.google.com/buttons/checkout.gif?merchant_id={$CONFIG['photo_shop_google_id']}&w={$CONFIG['photo_shop_google_button_width']}&h={$CONFIG['photo_shop_google_button_height']}&style={$CONFIG['photo_shop_google_button_style']}&variant=text&loc={$CONFIG['photo_shop_google_button_loc']}"  height="46" width="180"/>

					<input type="hidden" name="item_name_1" value="{$CONFIG['gallery_name']}"/>
					<input type="hidden" name="item_description_1" value="{$lang_photoshop['order_id']} {$order_id}"/>
					<input type="hidden" name="item_quantity_1" value="1"/>
					<input type="hidden" name="item_price_1" value="{$item_price}"/>
					<input type="hidden" name="item_currency_1" value="{$CONFIG['photo_shop_google_currency']}"/>
					<input type="hidden" name="ship_method_name_1" value="{$lang_photoshop['shipping']}"/>
    				<input type="hidden" name="ship_method_price_1" value="{$shipping_price}"/>
					</form>

EOT;
			}


			$msg_box_txt .= '<br><br><br>';


			msg_box('', $msg_box_txt, $lang_continue, 'index.php');

			//comment out if you don't want the orders to appeare on the order confirmed page
			starttable('100%', $lang_photoshop['myorders'], 1);
			echo photoshop_create_table($shop_array_photos, 'photo', 'html');
			echo photoshop_create_table($shop_array_cd, 'cd', 'html');
			echo photoshop_format_price($cd_price, $cd_counter, '', 'html');
			endtable();
			//now we just need to clear the cookie/ session and done
			setcookie($CONFIG['cookie_name'] . '_cart', '', time() + 86400 * 30, $CONFIG['cookie_path']);
			unset ($_SESSION['photoshop']['cart']);
		}



	pagefooter();
	ob_end_flush();
	exit; // we're done here
	} else {
		//something went wrong
	}

} else {
	//show the cart contents and price, submit button
	echo "<form action='{$_SERVER['PHP_SELF']}?file=photo_shop/photo_shop_checkout' method='post'>";

	photoshop_prep_data($shop_array_cd, $shop_array_photos);
	echo photoshop_create_table($shop_array_photos, 'photo', 'html');
	echo photoshop_create_table($shop_array_cd, 'cd', 'html');
	echo photoshop_format_price($cd_price, $cd_counter, '', 'html');

	echo <<<EOT
                <tr>
                        <td align="left" class="tablef" colspan="7">
                            <table border="0" cellspacing="0" cellpadding="0" width="100%">
                                <tr>
                                    <td width="100%" align="center">
                                        <input type="hidden" name="order" value="confirmed" />
                                        <input type="submit" class="button" name="apply" value="{$lang_photoshop['send_order']}" />
                                    </td>
                                </tr>
                            </table>
                        </td>
                </tr>
EOT;
}

endtable();
echo "</form>";
//printing a pricelist
photoshop_pricelist();
pagefooter();
ob_end_flush();

//functioons
function photoshop_prep_data(&$shop_array_cd, &$shop_array_photos){
	$shop_array_photos = array(); //temp array for easier use
	$shop_array_cd = array(); //temp array for easier use
	foreach ($_SESSION['photoshop']['cart'] as $key => $item_id) {
		if ($item_id['id'] == 'CD') {
			$shop_array_cd[] = $_SESSION['photoshop']['cart'][$key];
		} else {
			$shop_array_photos[] = $_SESSION['photoshop']['cart'][$key];
		}
	}
}

function photoshop_create_table($shop_array_photos, $type, $template){ //we create two basic templates html and text
	global $SHOP_CONFIG, $CONFIG, $lang_photoshop, $cd_price;

	$out = array();

	$out['html'] = '<tr><td><table cellpadding="0" cellspacing="1" width="100%">';
	$out['text'] = sprintf("%s\n\n", '');

	if ($type == 'photo') {
	$out['html'].= <<<EOT
		<tr>
			<td class="tableh1" width="25%">{$lang_photoshop['item_id_checkout']}</td>
			<td class="tableh1" width="25%">{$lang_photoshop['type_chckout']}</td>
			<td class="tableh1" width="25%">{$lang_photoshop['amount_checkout']}</td>
			<td class="tableh1" width="25%">{$lang_photoshop['total_checkout']}</td>
		</tr>
EOT;
	$out['text'].= sprintf("%10.10s\t", $lang_photoshop['item_id_checkout']).sprintf("%15.15s\t",$lang_photoshop['type_chckout']).sprintf("%10.10s\t",$lang_photoshop['amount_checkout']).sprintf("%15.15s\n",$lang_photoshop['total_checkout']);
	} elseif(($type == 'cd') && (photoshop_in_array_multi("CD", $shop_array_photos))) {
	$out['html'].= <<<EOT
		<tr>
			<td class="tableh1" width="25%">{$lang_photoshop['item_id_checkout']}</td>
			<td class="tableh1" width="25%">{$lang_photoshop['type_chckout']}</td>
			<td class="tableh1" width="25%">&nbsp;</td>
			<td class="tableh1" width="25%">&nbsp;</td>
		</tr>
EOT;
	$out['text'].= sprintf("%10.10s\t", $lang_photoshop['item_id_checkout']).sprintf("%15.15s\n",$lang_photoshop['type_chckout']);

	}
	foreach ($shop_array_photos as $key => $item_id) {
		$select_columns = 'filepath, filename, url_prefix, filesize, pwidth, pheight, ctime, title, aid';

	    $result = cpg_db_query("SELECT $select_columns from {$CONFIG['TABLE_PICTURES']} WHERE pid='{$item_id['pid']}' LIMIT 1");
	    $row = mysql_fetch_array($result);

		$price = $SHOP_CONFIG[$item_id['id']]['price'];

		//price override
		$results = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_SHOP_PRICES']} WHERE aid={$row['aid']}");

	    while ($temp_data = mysql_fetch_array($results)) {
			if($temp_data['gid']==$SHOP_CONFIG[$item_id['id']]['id'])
				$price=$temp_data['price'];
		}
		mysql_free_result($results);


		//html resize thumb
		if ($CONFIG['enable_mini_thumbs'] == '1') { // if you use the modpack and have enabled mini thumbs -> these get used instead of html resized thumbs
			$thumb_url = get_pic_url($row, 'mini');
		    $destWidth = $CONFIG['mini_thumb_width'];
		    $destHeight = $CONFIG['mini_thumb_height'];
		} else {
			$thumb_url = get_pic_url($row, 'thumb');
			$new_size = 60;
		    $ratio = max($row['pwidth'], $row['pheight']) / $new_size;
		    $ratio = max($ratio, 1.0);
		    $destWidth = (int)($row['pwidth'] / $ratio);
		    $destHeight = (int)($row['pheight'] / $ratio);
		}

		if ($item_id['id'] == 'CD') {
			$out['html'].= <<<EOT
				<tr>
					<td>
					<a href="displayimage.php?pos=-{$item_id['pid']}"><img class="image" src="{$thumb_url}" width="{$destWidth}" height="{$destHeight}" alt="" /></a>
					</td>
					<td>{$item_id['id']}</td>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
				</tr>
EOT;

			$out['text'].= sprintf("%10.10s\t", $item_id['pid']).sprintf("%15.15s\n",$item_id['id']);

		} else {
		$price = number_format($price*$item_id['amount'],2);
			$out['html'].=  <<<EOT
				<tr>
					<td>
					<a href="displayimage.php?pos=-{$item_id['pid']}"><img class="image" src="{$thumb_url}" width="{$destWidth}" height="{$destHeight}" alt="" /></a>
					</td>
					<td>{$SHOP_CONFIG[$item_id['id']]['name']}</td>
					<td>{$item_id['amount']}</td>
					<td>{$lang_photoshop['USD']} {$price}</td>
				</tr>
EOT;

			$out['text'].= sprintf("%10.10s\t", $item_id['pid']).sprintf("%15.15s\t", $SHOP_CONFIG[$item_id['id']]['name']).sprintf("%10.10s\t", $item_id['amount']).sprintf("%15.15s\n",$lang_photoshop['USD'].' '.$price);

		}
	}
	$out['html'] .= "</td></tr></table>";

	return $out[$template];
}

function photoshop_add_data($shop_data, $order_id){
	global $CONFIG, $SHOP_CONFIG, $cd_price, $cd_counter, $discount_calc, $shipping_price_calc;

	$otime = time();
	$picture_total = 0;
	foreach ($shop_data as $key => $item_id) {
		$pid = $item_id['pid'];
		$amount = $item_id['amount'];

		if ($item_id['id']=="CD") {
			$size = "CD";
			$price = $cd_price[1];
		} else {
			$size = $SHOP_CONFIG[$item_id['id']]['name'];
			$price = $SHOP_CONFIG[$item_id['id']]['price'];

			//price override
			$results = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_SHOP_PRICES']} WHERE aid={$item_id['aid']}");

		    while ($temp_data = mysql_fetch_array($results)) {
				if($temp_data['gid']==$SHOP_CONFIG[$item_id['id']]['id'])
					$price=$temp_data['price'];
			}
			mysql_free_result($results);

		$picture_total = ($picture_total+$price*$amount);
		}

		$results = cpg_db_query ("INSERT INTO `{$CONFIG['TABLE_SHOP']}` (`oid`, `uid`, `pid`, `quantity`, `size`, `price`, `otime`) VALUES ('$order_id', '".USER_ID."', '$pid', '$amount', '$size', '$price', '$otime')");

	}
	$results2 = cpg_db_query ("INSERT INTO `{$CONFIG['TABLE_SHOP']}` (`oid`, `uid`, `cd`, `quantity`, `price`, `otime`) VALUES ('$order_id', '".USER_ID."', '1', '".($cd_counter['cd']+$cd_counter['photo'])."', '".($picture_total+$cd_price[1]+$shipping_price_calc-$discount_calc)."', '$otime')");
	return $results;
}

function photoshop_email_the_user($message, $subject, $admin = '')
{
	global $CONFIG, $SHOP_CONFIG, $lang_photoshop, $cd_price, $order_id, $discount, $shipping_price;

	$user_info = photoshop_user_details(USER_ID);

	if ($admin) {
		$user_info['user_email']='admin';
	}

	$template_vars = array(
	'{ORDER_ID}' => $order_id,
	'{SITE_NAME}' => $CONFIG['gallery_name'],
	'{PRICE}' => number_format(($cd_price[0]+$cd_price[1]+$shipping_price-$discount),2),
	'{USER_NAME}' => (USER_NAME),
	'{ADMIN}' => $CONFIG['gallery_name'],
	'{LINK}' => $CONFIG['ecards_more_pic_target'],
	'{USER_PROFILE1}' => $user_info['user_profile1'],
	'{USER_PROFILE2}' => $user_info['user_profile2'],
	'{USER_PROFILE3}' => $user_info['user_profile3'],
	'{USER_PROFILE4}' => $user_info['user_profile4'],
	'{USER_PROFILE5}' => $user_info['user_profile5'],
	'{USER_PROFILE6}' => $user_info['user_profile6'],
	);
	$mail_body=nl2br(strtr($message, $template_vars));
	if(cpg_mail($user_info['user_email'], $subject, $mail_body, 'text/plain', $CONFIG['gallery_name'], $CONFIG['gallery_admin_email'] )) {
		return true;
	}
	return false;
}

function photoshop_user_details($id){
	global $cpg_udb;
	$user_name = $cpg_udb->get_user_infos($id);
	return $user_name;
}
?>